<?php

namespace Strig\Category\Adapter;

use Strig\Category\CategoryUrlGeneratorInterface;
use Strig\Gath\Gath;
use Psr\Container\ContainerInterface;
use Laminas\ServiceManager\Exception\ServiceNotCreatedException;
use Laminas\ServiceManager\Exception\ServiceNotFoundException;

class GathCategoryAdapterFactory
{

    /**
     * Create an object
     *
     * @param  ContainerInterface $container
     * @param string $requestedName
     * @param array|null $options
     * @throws ServiceNotFoundException if unable to resolve the service.
     * @throws ServiceNotCreatedException if an exception is raised when
     *     creating a service.
     * @return object
     */
    public function __invoke(ContainerInterface $container, string $requestedName, array $options = null)
    {
        return new GathCategoryAdapter(
            $container->get(Gath::class),
            $container->get(CategoryUrlGeneratorInterface::class)
        );
    }
}
