<?php

namespace Strig\Category;

use Psr\Container\ContainerInterface;
use Strig\Category\Repository\RepositoryPluginManager;
use Laminas\ServiceManager\Exception\ServiceNotCreatedException;
use Laminas\ServiceManager\Exception\ServiceNotFoundException;

class CategoryManagerFactory
{

    /**
     * Create an object
     *
     * @param  ContainerInterface $container
     * @param  string $requestedName
     * @param  null|array $options
     * @return object
     * @throws ServiceNotFoundException if unable to resolve the service.
     * @throws ServiceNotCreatedException if an exception is raised when
     *     creating a service.
     */
    public function __invoke(ContainerInterface $container, string $requestedName, array $options = null)
    {

        $repositories = $container->get(RepositoryPluginManager::class);

        return new CategoryManager($repositories);
    }
}
