<?php

namespace Strig\Category\Middleware;

use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use Psr\Http\Server\MiddlewareInterface;
use Psr\Http\Server\RequestHandlerInterface;
use Strig\Category\Repository\CategoryRepository;
use Laminas\Diactoros\Response\JsonResponse;

class CategoryAllMiddleware implements MiddlewareInterface
{

    protected $adapter;

    public function __construct(CategoryRepository $adapter)
    {
        $this->adapter = $adapter;
    }


    /**
     * Process an incoming server request and return a response, optionally delegating
     * response creation to a handler.
     * @param ServerRequestInterface $request
     * @param RequestHandlerInterface $handler
     * @return ResponseInterface
     */
    public function process(ServerRequestInterface $request, RequestHandlerInterface $handler): ResponseInterface
    {
        $data = $this->adapter->getAll();

        return new JsonResponse($data);
    }
}
