<?php

namespace Strig\Category\Middleware;

use Psr\Container\ContainerInterface;
use Strig\Category\CategoryManager;
use Strig\Category\Entity\Category;
use Strig\Category\Repository\CategoryRepository;

class CategoryImagesMiddlewareFactory
{
    public function __invoke(ContainerInterface $container)
    {
        /** @var CategoryManager $manager */
        $manager = $container->get(CategoryManager::class);

        /** @var CategoryRepository $repository */
        $repository = $manager->getRepository(Category::class);

        return new CategoryImagesMiddleware(
            $repository
        );
    }
}