<?php

namespace Strig\Category\Repository;

use Interop\Container\ContainerInterface;
use Laminas\ServiceManager\Exception\ServiceNotCreatedException;
use Laminas\ServiceManager\Exception\ServiceNotFoundException;

class RepositoryPluginManagerFactory
{

    /**
     * Create an object
     *
     * @param  ContainerInterface $container
     * @param string $requestedName
     * @param array|null $options
     * @throws ServiceNotFoundException if unable to resolve the service.
     * @throws ServiceNotCreatedException if an exception is raised when
     *     creating a service.
     * @return RepositoryPluginManager
     */
    public function __invoke(ContainerInterface $container, string $requestedName, array $options = null)
    {
        $config = $container->get('config');

        return new RepositoryPluginManager(
            $container,
            $config['repositories']
        );
    }
}
