<?php

namespace Strig\Category;

use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use Laminas\Diactoros\Response\JsonResponse;

trait RestDispatch
{

    public function handle(ServerRequestInterface $request): ResponseInterface
    {
        $method = strtolower($request->getMethod());

        if (method_exists($this, $method)) {
            return $this->$method($request);
        }

        return new JsonResponse(sprintf(
            'Method %s is not implemented for the requested resource',
            strtoupper($method)
        ));
    }
}
